; AisleRiot - Beleaguered Castle
; Copyright (C) 1998 Rosanna Yuen <rwsy@mit.edu>
;
; This game is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA

(define (new-game)
	(initialize-playing-area)
	(set-ace-low)
	(make-restricted-deck 2)
	(shuffle-deck)

	(add-slots)

	(set! tableau '(0 2 3 5 6 8 9 11))
	(set! foundations '(1 4 7 10))

	(deal-cards-face-up-from-deck DECK (append tableau tableau tableau
		tableau tableau tableau))

	(add-card! 1 (make-visible-card ace club))
	(add-card! 4 (make-visible-card ace diamond))
	(add-card! 7 (make-visible-card ace heart))
	(add-card! 10 (make-visible-card ace spade))

	(list 9 4)
)

(define (add-slots)
	(define card-half-width (quotient (get-card-width) 2))
	(define (add-row)
		(add-extended-slot '() right)
		(add-blank-slot)
		(add-blank-slot)
		(add-blank-slot)
		(add-normal-slot '())
		(set! HORIZPOS (+ HORIZPOS card-half-width))
		(add-extended-slot '() right)
		(add-carriage-return-slot)
	)

	(add-row)
	(add-row)
	(add-row)
	(add-row)
)

(define (next-tableau-card? card slot)
	(or
		(empty-slot? slot)
		(card-follows? card (get-top-card slot))
	)
)

(define (button-pressed slot-id card-list)
	(and
		(= (length card-list) 1)
		(not (= ace (get-value (car card-list))))
	)
)

(define (button-released start-slot card-list end-slot)
	(if (foundation? end-slot)
		(and
			(not (= start-slot end-slot))
			(next-foundation-card? (car card-list) end-slot)
			(move-n-cards! start-slot end-slot card-list)
			(add-to-score! 1)
		)
		(and
			(not (= start-slot end-slot))
			(next-tableau-card? (car card-list) end-slot)
			(move-n-cards! start-slot end-slot card-list)
			(if (foundation? start-slot)
				(add-to-score! -1)
				#t
			)
		)
	)
)
	
(define (button-clicked slot-id) 
  #f)

(define (button-double-clicked slot-id)
	(and
		(not (empty-slot? slot-id))
		(not (foundation? slot-id))
		(let ((dest (find-foundation-slot (get-top-card slot-id))))
			(and
				dest
				(add-card! dest (remove-card slot-id))
				(add-to-score! 1)
			)
		)
	)
)

(define (game-continuable)
	(not (game-won))
)

(define (game-won)
	(foundations-full?)
)

(define (get-hint)
	(or
		(or-map check-to-foundation tableau)
		(list 0 "Try rearranging the cards")
	)
)

(define (get-options) 
  #f)

(define (apply-options options) 
  #f)

(define (timeout) 
  #f)

(set-lambda new-game button-pressed button-released button-clicked
button-double-clicked game-continuable game-won get-hint get-options
apply-options timeout)
