; AisleRiot - fourteen.scm
; Copyright (C) 1999 Rosanna Yuen <rwsy@mit.edu>
;
; This game is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA

(define (new-game)
	(initialize-playing-area)
	(set-ace-low)
	(make-standard-deck)
	(shuffle-deck)

	(set! tableau '(0 1 2 3 4 5 6 7 8 9 10 11))

	(add-slots)

	(deal-cards-face-up-from-deck DECK
		(append tableau tableau tableau tableau '(0 1 2 3)))

	(list 6 3)
)

(define (add-slots)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)

	(add-carriage-return-slot)
	(set! VERTPOS (+ VERTPOS (quotient (* 3 (get-card-height)) 4)))

	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
)

(define (button-pressed slot-id card-list)
	(and
		(not (empty-slot? slot-id))
		(= 1 (length card-list))
	)
)

(define (card-to-tableau? card slot)
	(and
		(not (empty-slot? slot))
		(= 14 (+ (get-value (get-top-card slot)) (get-value card)))
	)
)

(define (button-released start-slot card-list end-slot)
	(and
		(not (= start-slot end-slot))
		(card-to-tableau? (car card-list) end-slot)
		(add-to-score! 2)
		(remove-card end-slot)
	)
)

(define (button-clicked slot-id)
  #f)

(define (button-double-clicked slot-id)
  #f)

(define (game-continuable)
	(and (not (game-won)) (get-hint))
)

(define (game-won)
	(and-map empty-slot? tableau)
)

(define (check-slot card slot2)
	(if (card-to-tableau? card slot2)
		(list 1 (get-name card) (get-name (get-top-card slot2)))
		(and
			(< slot2 11)
			(check-slot card (1+ slot2))
		)
	)
)

(define (check-tableau slot)
	(and
		(not (= 11 slot))
		(not (empty-slot? slot))
		(check-slot (get-top-card slot) (1+ slot))
	)
)

(define (get-hint)
	(or-map check-tableau tableau)
)

(define (get-options) 
  #f)

(define (apply-options options) 
  #f)

(define (timeout) 
  #f)

(set-lambda new-game button-pressed button-released button-clicked
button-double-clicked game-continuable game-won get-hint get-options
apply-options timeout)
