; AisleRiot - king_albert.scm
; Copyright (c) 2000 Matthew Wilcox <matthew@wil.cx>
;
; This game is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA

(define deal-three #f)

; The set up:

(define reserve '(4 5 6 7 8 9 10))
(define tableau '(11 12 13 14 15 16 17 18 19))

(define (new-game)
	(initialize-playing-area)
	(set-ace-low)

	(make-standard-deck)
	(shuffle-deck)
  
	(add-blank-slot)
	(add-blank-slot)
	(add-normal-slot DECK)
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())
	(set! foundations '(0 1 2 3))

	(add-carriage-return-slot)

	(add-blank-slot)
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())
	(add-normal-slot '())

	(add-carriage-return-slot)

	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)
	(add-extended-slot '() down)

	(deal-cards-face-up stock
		'( 4  5  6  7  8  9 10
		  11 12 13 14 15 16 17 18 19
		  11 12 13 14 15 16 17 18
		  11 12 13 14 15 16 17
		  11 12 13 14 15 16
		  11 12 13 14 15
		  11 12 13 14
		  11 12 13
		  11 12
		  11)
	)

	(give-status-message)

	(list 9 4)
)

(define (give-status-message)
	#f
)

(define (button-pressed slot-id card-list)
	(= (length card-list) 1)
)

(define (complete-transaction start-slot card-list end-slot)
  (move-n-cards! start-slot end-slot card-list)
  (if (foundation? start-slot)
      (add-to-score! -1))
  (if (foundation? end-slot)
      (add-to-score! 1))
  (if (and (not (empty-slot? start-slot)) 
	   (member start-slot tableau))
      (make-visible-top-card start-slot))
  #t)

(define (button-released start-slot card-list end-slot)
  (and (not (= start-slot end-slot))
       (or (and (member end-slot tableau)
		(if (empty-slot? end-slot)
		    #t
		    (and (not (eq? (is-red? (get-top-card end-slot))
				   (is-red? (car (reverse card-list)))))
			 (= (get-value (get-top-card end-slot))
			    (+ (get-value (car (reverse card-list))) 1)))))
	   (and (foundation? end-slot)
		(= 1 (length card-list))
		(next-foundation-card? (car card-list) end-slot)
	   )
	)
       (complete-transaction start-slot card-list end-slot)))

(define (button-clicked start-slot)
	#f
)

(define (button-double-clicked start-slot)
	(and
		(member start-slot (append reserve tableau))
		(not (empty-slot? start-slot))
		(let*	(
				(card (get-top-card start-slot))
				(end-slot (find-foundation-slot card))
			)
			(and
				end-slot
				(remove-card start-slot)
				(complete-transaction start-slot (list card) end-slot)
			)
		)
	)
)

(define (get-hint)
	(or
		(or-map check-to-foundation (append tableau reserve))
		(list 0 "No useful hints yet")
	)
)

(define (game-won)
	(foundations-full?)
)

(define (game-over)
  (give-status-message)
  (not (game-won)))

(define (get-options)
  (list (list "Three card deals" deal-three)))

(define (apply-options options)
  (set! deal-three (cadar options)))

(define (timeout) #f)

(set-lambda new-game button-pressed button-released button-clicked button-double-clicked game-over game-won get-hint get-options apply-options timeout)
