; AisleRiot - pileon.scm
; Copyright (C) 1998 Nick Lamb <njl195@zepler.org.uk>
;
; This game is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA

(define (new-game)
	(initialize-playing-area)
	(set-ace-low)
	(make-standard-deck)
	(shuffle-deck)

	(add-slots)

	(set! tableau '(0 1 2 3 4 5 6 7 8 9 10 11 12 13 14))

	(deal-cards-face-up-from-deck DECK '(0 0 0 0 1 1 1 1 2 2 2 2 3 3 3 3
		4 4 4 4 5 5 5 5 6 6 6 6 7 7 7 7 8 8 8 8 9 9 9 9 10 10 10 10
		11 11 11 11 12 12 12 12))

	(list 7 4)
)

(define (add-slots)
	(define (add-row)
		(add-partially-extended-slot '() right 4)
		(set! HORIZPOS (+ HORIZPOS 70))
		(add-partially-extended-slot '() right 4)
		(set! HORIZPOS (+ HORIZPOS 70))
		(add-partially-extended-slot '() right 4)
		(set! HORIZPOS (+ HORIZPOS 70))
		(add-partially-extended-slot '() right 4)
		(add-carriage-return-slot)
	)

	(add-row)
	(add-row)
	(add-row)

	(add-partially-extended-slot '() right 4)
	(set! HORIZPOS (+ HORIZPOS 70))
	(add-partially-extended-slot '() right 4)
	(set! HORIZPOS (+ HORIZPOS 70))
	(add-partially-extended-slot '() right 4)
	(add-carriage-return-slot)
)

(define (check-same-value-list card-list)
	(or
		(> 2 (length card-list))
		(and
			(value-eq? (car card-list) (cadr card-list))
			(check-same-value-list (cdr card-list))
		)
	)
)

(define (freeze-slot slot-id)
	(flip-top-card slot-id)
	(add-to-score! 4)
)

(define (button-pressed slot-id card-list)
	(and
		(check-same-value-list card-list)
		(is-visible? (car card-list))
	)
)

(define (button-released start-slot card-list end-slot)
	(and
		(or
			(empty-slot? end-slot)
			(value-eq? (car (get-cards end-slot)) (car card-list))
		)
		(< (+ (length (get-cards end-slot)) (length card-list)) 5)
		(move-n-cards! start-slot end-slot card-list)
		(if (and (= (length (get-cards end-slot)) 4)
			 (check-same-value-list (get-cards end-slot)))
			(freeze-slot end-slot)
			#t
		)
	)
)

(define (button-clicked slot-id) #f)

(define (button-double-clicked slot) #f)

(define (game-over) 
  (and (not (game-won))
       (get-hint)))

(define (game-won) 
	(= 52 (get-score))
)

(define (check-number slot-id)
	(define card-list (get-cards slot-id))
  (cond ((and (> (length card-list) 1)
	      (not (value-eq? (car card-list) (cadr card-list))))
	 1)
	((and (> (length card-list) 2)
	      (not (value-eq? (car card-list) (caddr card-list))))
	 2)
	((and (> (length card-list) 3)
	      (not (value-eq? (car card-list) (cadddr card-list))))
	 3)
	(#t 1)))

(define (check-a-slot slot-id number-to-move to-slot)
  (if (> to-slot 14)
      #f
      (if (= slot-id to-slot)
	  (check-a-slot slot-id number-to-move (+ 1 to-slot))
	  (cond ((empty-slot? slot-id)
		 (list 2 "something" "an empty slot"))
		((empty-slot? to-slot)
		 (list 2 "something" "an empty slot"))
		((= 4 (length (get-cards to-slot)))
		 (check-a-slot slot-id number-to-move (+ 1 to-slot)))
		((value-eq? (get-top-card to-slot) (get-top-card slot-id))
		 (if (> number-to-move (- 4 (length (get-cards to-slot))))
		     (check-a-slot slot-id 
				   (- number-to-move 
				      (- 4 (length (get-cards to-slot))))
				   (+ 1 to-slot))
		     (list 2 (get-name (get-top-card slot-id))
			   (get-name (get-top-card to-slot)))))
		(#t (check-a-slot slot-id number-to-move (+ 1 to-slot)))))))

(define (check-slots)
	(define (f slot)
		(check-a-slot slot (check-number slot) 0)
	)
	(or-map f tableau)
)

(define (get-hint)
	(check-slots)
)

(define (get-options) #f)

(define (apply-options options) #f)

(define (timeout) #f)

(set-lambda new-game button-pressed button-released button-clicked button-double-clicked game-over game-won get-hint get-options apply-options timeout)
