; AisleRiot - thirteen.scm
; Copyright (C) 1999 Rosanna Yuen <rwsy@mit.edu>
;
; This game is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA

(define (new-game)
  (initialize-playing-area)  
  (set-ace-low)
  (make-standard-deck)
  (shuffle-deck)

  (add-normal-slot DECK)
  (add-normal-slot '())
  (set! HORIZPOS (- HORIZPOS 60))
  (add-extended-slot '() right)

  (add-carriage-return-slot)

  (add-blank-slot)
  (add-blank-slot)
  (add-blank-slot)
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (set! HORIZPOS (+ HORIZPOS 42))
  (add-blank-slot)
  (add-blank-slot)
  (add-normal-slot '())
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (add-blank-slot)
  (add-blank-slot)
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (set! HORIZPOS (+ HORIZPOS 42))
  (add-blank-slot)
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (add-blank-slot)
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (set! HORIZPOS (+ HORIZPOS 42))
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())

  (add-carriage-return-slot)
  (set! VERTPOS (- VERTPOS 100))
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())
  (add-normal-slot '())

	(set! stock 0)

  (deal-cards 0 '( 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23))
  (deal-cards-face-up 0 '(24 25 26 27 28 29 30))

  (give-status-message)

  (list 7 4)
)

(define (give-status-message)
  (set-statusbar-message (get-stock-no-string)))

(define (button-pressed slot-id card-list)
  (and (not (empty-slot? slot-id))
       (is-visible? (car card-list))
       (= (length card-list) 1)))

(define (get-row-number slot)
	(cond
		((< slot 4) 1)
		((< slot 6) 2)
		((< slot 9) 3)
		((< slot 13) 4)
		((< slot 18) 5)
		((< slot 24) 6)
		((< slot 31) 7)
	)
)

(define (check-parents slot)
	(or
		(= slot 24)
		(let ((rowno (get-row-number slot)))
			(and
				(not (empty-slot? slot))
				(empty-slot? (+ slot rowno))
				(empty-slot? (+ slot rowno 1))
				(make-visible-top-card slot)
			)
			#f
		)
		(check-parents (+ 1 slot))
	)
)

(define (handle-waste)
	(and
		(empty-slot? 1)
		(not (empty-slot? 2))
		(let ((new-contents (reverse (get-cards 2))))
			(set-cards! 1 (list (car new-contents)))
			(set-cards! 2 (reverse (cdr new-contents)))
		)
	)
	#t
)

(define (button-released start-slot card-list end-slot)
	(if (= start-slot end-slot)
		(and
			(= (get-value (car card-list)) king)
			(add-to-score! 1)
			(check-parents 3)
		)
		(and
			(not (empty-slot? end-slot))
			(is-visible? (get-top-card end-slot))
			(= 13 (+ (get-value (car card-list))
				(get-value (get-top-card end-slot))))
			(remove-card end-slot)
			(add-to-score! 2)
			(check-parents 3)
			(handle-waste)
		)
	)
)

(define (button-clicked slot-id)
	(if (= slot-id 0)
		(and
			(not (empty-slot? 0))
			(or
				(empty-slot? 1)
				(set-cards! 2 (append (get-cards 2)
					(list (remove-card 1))))
			)
			(deal-cards-face-up 0 '(1))
		)
		(and
			(not (empty-slot? slot-id))
			(is-visible? (get-top-card slot-id))
			(= (get-value (get-top-card slot-id)) king)
			(remove-card slot-id)
			(add-to-score! 1)
			(check-parents 3)
			(handle-waste)
		)
	)
)

(define (button-double-clicked slot-id)
  #f)

(define (game-continuable)
  (give-status-message)
  (and (not (game-won))
       (get-hint)))

(define (game-won)
  (and (empty-slot? 3)
       (empty-slot? 1)
       (empty-slot? 0)))

(define (check-move slot1 slot2)
  (if (or (empty-slot? slot1)
	  (not (is-visible? (get-top-card slot1))))
      (if (< slot1 29)
	  (check-move (+ 1 slot1) (+ 2 slot1))
	  #f)
      (if (= king (get-value (get-top-card slot1)))
	  (list 2 (get-name (get-top-card slot1)) "itself")
	  (if (or (empty-slot? slot2)
		  (not (is-visible? (get-top-card slot2)))
		  (not (= 13 (+ (get-value (get-top-card slot1))
				(get-value (get-top-card slot2))))))
	      (if (< slot2 30)
		  (check-move slot1 (+ 1 slot2))
		  (if (< slot1 29)
		      (check-move (+ 1 slot1) (+ 2 slot1))
		      #f))
	      (list 1 
		    (get-name (get-top-card slot1)) 
		    (get-name (get-top-card slot2)))))))

(define (get-hint)
	(or
		(check-move 1 2)
		(deal-hint)
	)
)

(define (get-options) 
  #f)

(define (apply-options options) 
  #f)

(define (timeout) 
  #f)

(set-lambda new-game button-pressed button-released button-clicked
button-double-clicked game-continuable game-won get-hint get-options
apply-options timeout)
